'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash.kebabcase');

var _lodash2 = _interopRequireDefault(_lodash);

var _transactionsExpressPassport = require('transactions-express-passport');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var setCustomizer = function setCustomizer(customizersByCollectionName) {
  customizersByCollectionName['users'] = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(document) {
      var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var db, _document$local, firstName, lastName, tour, relativeMatch;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              db = config.db;

              if (!document.id) {
                document.id = (0, _transactionsExpressPassport.generateUserId)();
              }
              if (!document.activationHash) {
                document.activationHash = (0, _transactionsExpressPassport.generateActivationHash)();
              }
              if (!document.local) {
                document.local = {};
              }
              if (!document.slug) {
                _document$local = document.local, firstName = _document$local.firstName, lastName = _document$local.lastName;

                document.slug = (0, _lodash2.default)(firstName + '-' + lastName);
              }

              if (document.local.password) {
                _context.next = 22;
                break;
              }

              if (!document.local.tourPassword) {
                _context.next = 13;
                break;
              }

              _context.next = 9;
              return (0, _transactionsExpressPassport.generateHash)(document.local.tourPassword);

            case 9:
              document.local.password = _context.sent;

              delete document.local.tourPassword;
              _context.next = 20;
              break;

            case 13:
              _context.next = 15;
              return db.collection('tours').findOne({ userId: document.id });

            case 15:
              tour = _context.sent;

              if (!tour) {
                _context.next = 20;
                break;
              }

              _context.next = 19;
              return (0, _transactionsExpressPassport.generateHash)(tour.password);

            case 19:
              document.local.password = _context.sent;

            case 20:
              _context.next = 32;
              break;

            case 22:
              relativeMatch = document.local.password.match(/\{\{(.*)\}\}/);

              if (!(relativeMatch && relativeMatch[1])) {
                _context.next = 29;
                break;
              }

              _context.next = 26;
              return (0, _transactionsExpressPassport.generateHash)(relativeMatch[1]);

            case 26:
              document.local.password = _context.sent;
              _context.next = 32;
              break;

            case 29:
              _context.next = 31;
              return (0, _transactionsExpressPassport.generateHash)((0, _transactionsExpressPassport.generateUserId)().split('user_')[1]);

            case 31:
              document.local.password = _context.sent;

            case 32:
              return _context.abrupt('return', document);

            case 33:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();
};

exports.default = setCustomizer;