'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.credentialData = credentialData;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _transactionsExpressPassport = require('transactions-express-passport');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function credentialData() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  // unpack
  var fileDir = config.fileDir || __dirname + '/../../data/json_data/';
  var type = config.type || 'development';
  var fileName = config.fileName || type + '_climate-feedback-users.json';
  var userName = config.userName;
  // get users
  var filePath = _path2.default.join(fileDir, fileName);
  if (!_fs2.default.existsSync(filePath)) {
    console.warn('No such file ' + filePath);
    return;
  }
  var users = JSON.parse(_fs2.default.readFileSync(filePath));
  // set
  var credentialsByName = {};
  users.forEach(function (_ref) {
    var randomPassword = _ref.randomPassword,
        first_name = _ref.first_name,
        last_name = _ref.last_name,
        user_email = _ref.user_email;

    credentialsByName[first_name + ' ' + last_name] = {
      email: user_email,
      password: randomPassword
    };
  });
  // get maybe specific user
  if (userName) {
    var credential = credentialsByName[program.name];
    credentialsByName = _defineProperty({}, program.name, credential);
    (0, _transactionsExpressPassport.generateHash)(credential.password).then(function (hash) {
      return console.log('hash: ' + hash);
    });
  }
  // console
  console.log(JSON.stringify(credentialsByName, null, 2));
}