'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mockData = exports.mock = undefined;

var mock = exports.mock = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(description) {
    var _this = this;

    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var _description, models, db, jsonDataDir, hasProtection, modelsByCreateIndex, maxCreateIndex, createIndexes, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, index, _models;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            // determine description
            _description = description.isSet ? description : (0, _transactionsDescriptionDefinition.createDescription)(description);

            if (!(!_description || !_description.models)) {
              _context3.next = 4;
              break;
            }

            console.warn('did not find models in the description');
            return _context3.abrupt('return');

          case 4:
            models = _description.models;
            // unpack

            db = config.db, jsonDataDir = config.jsonDataDir;
            hasProtection = typeof config.hasProtection === 'undefined' ? true : config.hasProtection;
            // maybe some collection needs data from already set collections
            // and for that we use a createIndex to group by the collections
            // that can be set asynchronously

            modelsByCreateIndex = (0, _lodash4.default)(models, function (model) {
              return model.createIndex || 0;
            });
            maxCreateIndex = Math.max.apply(Math, _toConsumableArray(Object.keys(modelsByCreateIndex)));
            createIndexes = Array.apply(null, { length: maxCreateIndex + 1 }).map(Number.call, Number);
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context3.prev = 13;
            _iterator = createIndexes[Symbol.iterator]();

          case 15:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context3.next = 23;
              break;
            }

            index = _step.value;
            _models = modelsByCreateIndex[index];
            _context3.next = 20;
            return Promise.all(_models.map(function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref3) {
                var isProtected = _ref3.isProtected,
                    entityName = _ref3.entityName;
                var collectionName, insertedDocuments, fileDir, fileString, customizer, result;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        if (!(hasProtection && isProtected)) {
                          _context2.next = 2;
                          break;
                        }

                        return _context2.abrupt('return');

                      case 2:
                        collectionName = (0, _pluralize2.default)(entityName, 2);
                        // read

                        insertedDocuments = void 0;
                        fileDir = _path2.default.join(jsonDataDir, collectionName + '.json');

                        if (_fs2.default.existsSync(fileDir)) {
                          _context2.next = 8;
                          break;
                        }

                        console.warn('No such file ' + fileDir);
                        return _context2.abrupt('return');

                      case 8:
                        fileString = _fs2.default.readFileSync(fileDir).toString('utf-8');

                        insertedDocuments = JSON.parse(fileString);

                        if (!(insertedDocuments.length === 0)) {
                          _context2.next = 12;
                          break;
                        }

                        return _context2.abrupt('return');

                      case 12:
                        // customizers
                        customizer = _customizers2.default[collectionName] || _customizers2.default.defaults;

                        if (!customizer) {
                          _context2.next = 19;
                          break;
                        }

                        _context2.t0 = _lodash2.default;
                        _context2.next = 17;
                        return Promise.all(insertedDocuments.map(function () {
                          var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(insertedDocument) {
                            return regeneratorRuntime.wrap(function _callee$(_context) {
                              while (1) {
                                switch (_context.prev = _context.next) {
                                  case 0:
                                    _context.next = 2;
                                    return customizer(insertedDocument, { db: db });

                                  case 2:
                                    return _context.abrupt('return', _context.sent);

                                  case 3:
                                  case 'end':
                                    return _context.stop();
                                }
                              }
                            }, _callee, _this);
                          }));

                          return function (_x4) {
                            return _ref4.apply(this, arguments);
                          };
                        }()));

                      case 17:
                        _context2.t1 = _context2.sent;
                        insertedDocuments = (0, _context2.t0)(_context2.t1);

                      case 19:
                        _context2.next = 21;
                        return (0, _transactionsExpressRestMongodb.add)(insertedDocuments, { collectionName: collectionName, db: db });

                      case 21:
                        result = _context2.sent;

                      case 22:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, _this);
              }));

              return function (_x3) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 20:
            _iteratorNormalCompletion = true;
            _context3.next = 15;
            break;

          case 23:
            _context3.next = 29;
            break;

          case 25:
            _context3.prev = 25;
            _context3.t0 = _context3['catch'](13);
            _didIteratorError = true;
            _iteratorError = _context3.t0;

          case 29:
            _context3.prev = 29;
            _context3.prev = 30;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 32:
            _context3.prev = 32;

            if (!_didIteratorError) {
              _context3.next = 35;
              break;
            }

            throw _iteratorError;

          case 35:
            return _context3.finish(32);

          case 36:
            return _context3.finish(29);

          case 37:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this, [[13, 25, 29, 37], [30,, 32, 36]]);
  }));

  return function mock(_x) {
    return _ref.apply(this, arguments);
  };
}();

var mockData = exports.mockData = function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(description, config) {
    var mongoUrl, db;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            mongoUrl = config.mongoUrl;
            _context4.next = 3;
            return _mongodb.MongoClient.connect(mongoUrl);

          case 3:
            db = _context4.sent;
            _context4.next = 6;
            return mock(description, Object.assign({ db: db }, config));

          case 6:
            db.close();

          case 7:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function mockData(_x5, _x6) {
    return _ref5.apply(this, arguments);
  };
}();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _lodash = require('lodash.flatten');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.groupby');

var _lodash4 = _interopRequireDefault(_lodash3);

var _mongodb = require('mongodb');

var _transactionsExpressRestMongodb = require('transactions-express-rest-mongodb');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _pluralize = require('pluralize');

var _pluralize2 = _interopRequireDefault(_pluralize);

var _transactionsDescriptionDefinition = require('transactions-description-definition');

var _customizers = require('../customizers');

var _customizers2 = _interopRequireDefault(_customizers);

var _reset = require('./reset');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }