'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseData = undefined;

var parseData = exports.parseData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(urlOrUrls) {
    var _this = this;

    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var appSchema, bucketName, collectionName, pythonUrl, urls, s3, result;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            // unpack
            appSchema = config.appSchema, bucketName = config.bucketName, collectionName = config.collectionName, pythonUrl = config.pythonUrl;
            urls = Array.isArray(urlOrUrls) ? urlOrUrls : [urlOrUrls];
            // s3

            s3 = config.s3 || (0, _s.getS3)(config);
            // init

            result = {};
            // parse

            _context2.next = 6;
            return Promise.all(urls.map(function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url) {
                var entity, normalizedPatch;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return (0, _scrapDansTesMains.parse)(url, { pythonUrl: pythonUrl });

                      case 2:
                        entity = _context.sent;

                        entity.id = _transactionsToolsIsomorphic.SCRAP;
                        // normalize
                        normalizedPatch = (0, _transactionsReduxNormalizer.getNormalizedPatch)(_defineProperty({}, collectionName + 'ById', _defineProperty({}, _transactionsToolsIsomorphic.SCRAP, entity)), { appSchema: appSchema, isDeleteJoin: true });
                        // return

                        return _context.abrupt('return', normalizedPatch);

                      case 6:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x3) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 6:
            result.patches = _context2.sent;

            // impedance
            if (result.patches.length === 1) {
              result.patch = result.patches[0];
              delete result.patches;
            }
            // return
            return _context2.abrupt('return', result);

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function parseData(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _scrapDansTesMains = require('scrap-dans-tes-mains');

var _transactionsReduxNormalizer = require('transactions-redux-normalizer');

var _transactionsToolsIsomorphic = require('transactions-tools-isomorphic');

var _s = require('../utils/s3');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }