'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetData = exports.reset = undefined;

var reset = exports.reset = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(description) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var _description, models, db, hasProtection, items, collectionNames;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _description = description.isSet ? description : (0, _transactionsDescriptionDefinition.createDescription)(description);

            if (!(!_description || !_description.models)) {
              _context2.next = 4;
              break;
            }

            console.warn('did not find models in the description');
            return _context2.abrupt('return');

          case 4:
            models = _description.models;
            db = config.db;
            hasProtection = typeof config.hasProtection === 'undefined' ? true : config.hasProtection;
            _context2.next = 9;
            return db.listCollections().toArray();

          case 9:
            items = _context2.sent;
            collectionNames = items.map(function (item) {
              return item.name;
            });
            _context2.next = 13;
            return Promise.all(models.map(function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref3) {
                var isProtected = _ref3.isProtected,
                    entityName = _ref3.entityName;
                var collectionName;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        if (!(hasProtection && isProtected)) {
                          _context.next = 2;
                          break;
                        }

                        return _context.abrupt('return');

                      case 2:
                        collectionName = (0, _pluralize2.default)(entityName, 2);

                        if (!collectionNames.includes(collectionName)) {
                          _context.next = 6;
                          break;
                        }

                        _context.next = 6;
                        return db.collection(collectionName).drop();

                      case 6:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, this);
              }));

              return function (_x3) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 13:
            return _context2.abrupt('return', _context2.sent);

          case 14:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function reset(_x) {
    return _ref.apply(this, arguments);
  };
}();

var resetData = exports.resetData = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(description, config) {
    var mongoUrl, db;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            mongoUrl = config.mongoUrl;
            _context3.next = 3;
            return _mongodb.MongoClient.connect(mongoUrl);

          case 3:
            db = _context3.sent;
            _context3.next = 6;
            return reset(description, Object.assign({ db: db }, config));

          case 6:
            db.close();

          case 7:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function resetData(_x4, _x5) {
    return _ref4.apply(this, arguments);
  };
}();

var _mongodb = require('mongodb');

var _pluralize = require('pluralize');

var _pluralize2 = _interopRequireDefault(_pluralize);

var _transactionsDescriptionDefinition = require('transactions-description-definition');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }