'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.restoreData = undefined;

var restoreData = exports.restoreData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var _this = this;

    var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var awsConfig, bucketName, mongoUrl, fromType, dirName, subBucketName, timeIndex, urlMatch, databaseName, genericDatabaseName, fromDatabaseName, listObjectsConfig, s3;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            // config
            awsConfig = config.awsConfig, bucketName = config.bucketName, mongoUrl = config.mongoUrl, fromType = config.fromType;
            dirName = config.dirName || 'backup';
            subBucketName = config.subBucketName || 'backups';
            timeIndex = config.timeIndex || 0;
            // url

            urlMatch = mongoUrl.match(/mongodb\:\/\/((.*):(.*)@)?(.*):(.*)\/(.*)/);

            if (!(!urlMatch || !urlMatch[4] || !urlMatch[5] || !urlMatch[6])) {
              _context2.next = 8;
              break;
            }

            console.warn('wrong shape gor mongoUrl');
            return _context2.abrupt('return');

          case 8:
            databaseName = urlMatch[6];
            genericDatabaseName = databaseName.split('-').slice(1).join('-');
            fromDatabaseName = fromType === 'production' ? genericDatabaseName : fromType + '-' + genericDatabaseName;
            // s3

            _awsSdk2.default.config.update(awsConfig);
            listObjectsConfig = {
              Bucket: bucketName,
              Prefix: subBucketName + '/' + fromDatabaseName
            };
            s3 = new _awsSdk2.default.S3();

            s3.listObjects(listObjectsConfig, function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(err, data) {
                var object, getObjectConfig, uploadConfig, file;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        if (!err) {
                          _context.next = 2;
                          break;
                        }

                        throw err;

                      case 2:
                        object = data.Contents[Math.max(0, data.Contents.length - 1 - timeIndex)];
                        getObjectConfig = {
                          Bucket: bucketName,
                          Key: '' + object.Key
                        };
                        uploadConfig = Object.assign({
                          ContentType: 'application/x-gzip'
                        }, getObjectConfig);
                        file = _fs2.default.createWriteStream(dirName + '.gz');

                        file.on('close', function () {
                          // clean
                          _child_process2.default.execSync('rm -rf ' + dirName + ' && mkdir ' + dirName + ' && mkdir ' + dirName + '/' + databaseName + ' && tar -xvzf ' + dirName + '.gz -C ' + dirName);
                          // restore
                          var command = 'mongorestore --gzip --drop --host ' + urlMatch[4] + ' --port ' + urlMatch[5] + ' --db ' + databaseName;
                          if (urlMatch[2] && urlMatch[3]) {
                            command = command + ' --username ' + urlMatch[2] + ' --password ' + urlMatch[3];
                          }
                          command = command + ' --nsInclude \'*\' ' + dirName + '/' + fromDatabaseName;
                          console.log(command);
                          _child_process2.default.execSync(command);
                          // erase what was written temp
                          _child_process2.default.execSync('rm -rf ' + dirName + ' && rm -f ' + dirName + '.gz');
                        });
                        _context.next = 9;
                        return s3.getObject(getObjectConfig).createReadStream().pipe(file);

                      case 9:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x2, _x3) {
                return _ref2.apply(this, arguments);
              };
            }());

          case 15:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function restoreData() {
    return _ref.apply(this, arguments);
  };
}();

var _awsSdk = require('aws-sdk');

var _awsSdk2 = _interopRequireDefault(_awsSdk);

var _child_process = require('child_process');

var _child_process2 = _interopRequireDefault(_child_process);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }