'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var signData = exports.signData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(mongoUrl) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var modeName, db, adminTours, _adminTours$, password, email;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // unpack
            modeName = config.modeName || 'admin';
            // connect

            _context.next = 3;
            return MongoClient.connect(mongoUrl);

          case 3:
            db = _context.sent;
            _context.next = 6;
            return db.collection('tours').aggregate([{ $match: { modeName: modeName } }, { $lookup: {
                from: 'users',
                localField: 'userId',
                foreignField: 'id',
                as: 'user'
              } }, {
              '$unwind': { path: '$user',
                preserveNullAndEmptyArrays: true
              }
            }]).toArray();

          case 6:
            adminTours = _context.sent;
            _adminTours$ = adminTours[0], password = _adminTours$.password, email = _adminTours$.user.local.email;
            // close

            db.close();
            // return
            return _context.abrupt('return', { email: email, password: password });

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function signData(_x) {
    return _ref.apply(this, arguments);
  };
}();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var _require = require('mongodb'),
    MongoClient = _require.MongoClient;