'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDescriptionFromDir = createDescriptionFromDir;

var _nodeDir = require('node-dir');

var _nodeDir2 = _interopRequireDefault(_nodeDir);

var _lodash = require('lodash.keyby');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _pluralize = require('pluralize');

var _pluralize2 = _interopRequireDefault(_pluralize);

var _transactionsDescriptionDefinition = require('transactions-description-definition');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createDescriptionFromDir(dir, config) {
  // unpack
  var isAllJoins = config.isAllJoins,
      isAllDeepJoins = config.isAllDeepJoins;
  // files

  var files = _nodeDir2.default.files(dir, { sync: true });
  // models
  var models = files.filter(function (file) {
    return (/(.*).js/.test(file)
    );
  }).map(function (file) {
    var modelName = file.split('models/').slice(-1)[0].replace('.js', '');
    if (modelName !== (0, _pluralize2.default)(modelName, 2)) {
      console.warn(modelName + ' is not a proper collectionName');
    }
    var moduleDir = _path2.default.join(dir, modelName);
    var model = require(moduleDir).default;
    if (model) {
      model.collectionName = modelName;
    } else {
      console.log('There is no model here ' + moduleDir);
    }
    return model;
  }).filter(function (model) {
    return model;
  });

  // description
  var descriptionConfig = { collectionNames: models.map(function (_ref) {
      var collectionName = _ref.collectionName;
      return collectionName;
    }),
    models: models,
    isAllDeepJoins: isAllDeepJoins,
    isAllJoins: isAllJoins
    // return
  };return (0, _transactionsDescriptionDefinition.createDescription)(descriptionConfig);
}